<?php
// (c) 2005, 2006 Michael Schierl
// #include <gpl.txt>

error_reporting(E_ALL);
define('WAS_REQUIRED', true);
require("include.php");
define('HEADERINDEX', 4);
$pageTitle="Gruppenliste";
require("../globalheader.php");
?>
<h1>Interaktive Gruppenliste des OpenNewsNetworks</h1>

<?=last_update()?>

<h2>Gruppenliste nach Kategorien</h2>

Die Zahlen in der Tabelle geben die insgesamte Anzahl an Postings in der Kategorie an.

<table border="1">
<?
server_header();

if (isset($_GET['hierarchy'])) {
	$hierarchy = $_GET['hierarchy'];
} else if (isset($_GET['h'])) {
	$hierarchy = $_GET['h'];
} else {
	$hierarchy = '';
}
if (isset($_SERVER['PATH_INFO'])) {
	$hierarchy = substr($_SERVER['PATH_INFO'],1);
}
if ($hierarchy != '') {
	$where = ' AND c.hierarchy = ' . parse_hierarchy($hierarchy);
} else {
       $where = '';
}
$sql = "SELECT c.id, c.name, cs.server, cs.count , c.groupcount
         FROM grouplist_categories c, grouplist_cat_server cs
         WHERE c.id = cs.category ".$where ."
         ORDER BY c.name";
$result = mysql_query($sql, $dbconn);
if (!$result) {
     die("SQL error query catgroups: " . mysql_error());
}

$lastcat = null;
$lastid = null;
$lastgcount = null;
$catdata = null;
$maxcount = null;

function showcat ($lastcat, $lastid, $lastgcount, $catdata, $maxcount) {
	global $servers;
	echo '<tr><td><a href="groups.php?category='.$lastid . '">'.
		$lastcat.'</a>';
	if ($lastgcount != 1) {
		echo " (".$lastgcount." Gruppen)";
	}
	echo '</td>';
	foreach($servers as $server) {
		echo '<td>';
		if (!isset($catdata[$server])) {
			echo '-';
		} else {
			$x = $catdata[$server];
			if ($maxcount == 0) 
				$percent = 100;
			else
				$percent = intval($x * 100 / $maxcount);
			echo $x . ' (' . $percent . '%)';
		}
		echo '</td>';
	}
	echo '</tr>';

}

while ($row = mysql_fetch_row($result)) {
	$id = $row[0];
	$cat = $row[1];
	$server =$row[2];
	$count = $row[3];
	$gcount=$row[4];
	if ($lastid != $id) {
		if ($lastcat != null) {
			showcat($lastcat, $lastid, $lastgcount, 
				$catdata, $maxcount);
		}
		$lastcat = $cat;
		$lastid= $id;
		$lastgcount = $gcount;
		$catdata = array();
		$maxcount = 0;
	}
	$catdata[$server] = $count;
	if ($maxcount < $count) $maxcount = $count;
}
if ($lastcat != null) {
	showcat($lastcat, $lastid, $lastgcount, $catdata, $maxcount);
}
?>
</table>

<hr>
(c) 2005, 2006 Michael Schierl
<?php writePageEnd();?>