<?php
// (c) 2005 Michael Schierl
// #include <gpl.txt>

error_reporting(E_ALL);
define('WAS_REQUIRED', true);
require("include.php");
define('HEADERINDEX', 4);
$pageTitle="Gruppenliste";
require("../globalheader.php");
?>
<h1>Interaktive Gruppenliste des OpenNewsNetworks</h1>

<?=last_update()?>

<h2>Gruppenliste</h2>

Die Zahlen in der Tabelle geben die insgesamte Anzahl an Postings in der Gruppe an.
Die erste und letzte Gruppe auf einer Seite (so mehrere vorhanden) kann unvollstndig 
sein. <tt>:-(</tt>

<?php

if (isset($_SERVER['PATH_INFO'])) {
	$path = substr($_SERVER['PATH_INFO'], 1);
	if (preg_match("~^[a-z0-9_-]+$~", $path)) {
		// hierarchy name
		$where = ', grouplist_categories c 
	                  WHERE g.category = c.id 
	                  AND c.hierarchy = ' . parse_hierarchy($path);
	} else if (preg_match("~^[a-zA-Z0-9_.-]+,[0-9]+$~", $path)) {
		$category = preg_replace("~^.*,~", "", $path);
		$where = "WHERE g.category = " . intval($category);
	} else if (preg_match("~^[a-zA-Z0-9_.-]+$~", $path)) {
	       	$where= "WHERE g.name = '".$path."'";
	} else {
		$where="WHERE 1=0";
	}
} else if (isset($_GET['hierarchy'])) {
	$where = ', grouplist_categories c 
                  WHERE g.category = c.id 
                        AND c.hierarchy = ' . intval($_GET['hierarchy']);
} else if (isset($_GET['h'])) {
	$where = ', grouplist_categories c 
                  WHERE g.category = c.id 
                        AND c.hierarchy = ' . parse_hierarchy($_GET['h']);	
} else if (isset($_GET['category'])) {
	$where="WHERE g.category = " . intval($_GET['category']);
} else if (isset($_GET['wildmat'])) {
	$wmat = $_GET['wildmat'];
	$wmat = str_replace("*", "%", $wmat);
	$where = "WHERE g.name LIKE '" . addslashes($wmat)."'";
} else {
	$where = "";
}
$query = "groups.php?" . $_SERVER['QUERY_STRING'];
if (isset($_GET['p'])) {
	$page = intval($_GET['p']);
	$query=preg_replace('~&p=-?[0-9]+$~','', $query);
} else {
	$page = 1;
}
$query .= '&amp;p=';

$capsonly = isset($_GET['capsonly']);
if ($capsonly) $page=-1;


$sql = "SELECT count(*)
         FROM grouplist_groups g 
         ".$where;
$result = mysql_query($sql, $dbconn);
if (!$result) {
     die("SQL error query count: " . mysql_error());
}
if ($row = mysql_fetch_row($result)) {
	$count=$row[0];
	$pages = intval(($count + GROUPS_PER_PAGE - 1) / GROUPS_PER_PAGE);
} else {
     die("SQL error query count: " . mysql_error());
}
pagination($query, $page, $pages);
?>

<table border="1">
<?php
server_header();

if ($page == 0) {
	$limit= '';
} else {
	$limit='LIMIT '. ($page-1) * GROUPS_PER_PAGE . ', ' . GROUPS_PER_PAGE;
}
$sql = "SELECT g.name, g.server, g.count
         FROM grouplist_groups g 
         ".$where. "
         ORDER BY g.name " . $limit;
$result = mysql_query($sql, $dbconn);
if (!$result) {
     die("SQL error query groups: " . mysql_error());
}

$lastgroup = null;
$groupdata = null;
$maxcount = null;

function showgroup ($lastgroup, $groupdata, $maxcount) {
	global $servers;
	echo '<tr><td>'.$lastgroup.'</td>';
	foreach($servers as $server) {
		echo '<td>';
		if (!isset($groupdata[$server])) {
			echo '-';
		} else {
			$x = $groupdata[$server];
			if ($maxcount == 0) 
				$percent = 100;
			else
				$percent = intval($x * 100 / $maxcount);
			echo $x . ' (' . $percent . '%)';
		}
		echo '</td>';
	}
	echo '</tr>';
}

while ($row = mysql_fetch_row($result)) {
	$group = $row[0];
	if ($capsonly && !preg_match("~[A-Z]~", $group))
		continue;
	$server =$row[1];
	$count = $row[2];
	if ($lastgroup != $group) {
		if ($lastgroup != null) {
			showgroup($lastgroup, $groupdata, $maxcount);
		}
		$lastgroup = $group;
		$groupdata = array();
		$maxcount = 0;
	}
	$groupdata[$server] = $count;
	if ($maxcount < $count) $maxcount = $count;
}
if ($lastgroup != null) {
	showgroup($lastgroup, $groupdata, $maxcount);
}
echo "</table>\n";
pagination($query, $page, $pages);

?>

<hr>
(c) 2005, 2006 Michael Schierl
<?php writePageEnd();?>