<?php
// (c) 2005, 2006 Michael Schierl
// #include <gpl.txt>

error_reporting(E_ALL);
define('WAS_REQUIRED', true);
require("include.php");
ini_set("session.use_cookies", 0);
ini_set('memory_limit', '8M'); // should be enough

// functions here

function fetch_groups($id, $name) {
	global $dbconn;
	echo 'Now fetching group list from ' . $name ."<br>\n";
	$username = get_config('nntp_user');
	$password = get_config('nntp_pass');
	$fp=fsockopen($name, 119, $errno, $errstr, 20);
	socket_set_timeout($fp, 60, 0);
	if (!$fp) {
		die ("Could not connect to server");
	}
	check_line($fp, "20", 1);
	fputs($fp, "MODE READER\r\n");
	check_line($fp, "20", 2);
	fputs($fp, "AUTHINFO USER ".$username."\r\n");
	check_line($fp, "381 ", 3);
	fputs($fp, "AUTHINFO PASS ".$password."\r\n");
	check_line($fp, "281 ", 4);
	fputs($fp, "LIST\r\n");
	check_line($fp, "215 ", 5);
	$gcount = 0;
	while(true) {
		$line = fgets($fp, 1024);
		$line=preg_replace("~[\r\n]+$~", "", $line);
		//		echo "\n". $line;
		if ($line == '.') break;
		$gcount++;
		$tokens = explode(' ', $line);
		$group = $tokens[0];
		$count = intval($tokens[1]) - intval($tokens[2]);
		if ($count<0) $count = 0;
		
		$sql = "INSERT INTO grouplist_groups_temp (server, name, count)
                          VALUES ('". intval($id) ."', 
                                  '". addslashes($group) ."', 
                                  ". intval($count) .")";
		$result = mysql_query($sql, $dbconn);
		if (!$result)
			echo ("SQL error INSERT group: " . mysql_error() . "\n");
	}
	echo "Read $gcount groups from $name.\n";
	fputs($fp, "QUIT\r\n");
	check_line($fp, "205 ", 6);
	fclose($fp);
}

function check_line($fp, $prefix, $when) {
	$line = fgets($fp, 1024);
	if (substr($line, 0, strlen($prefix)) != $prefix) {
		echo ("Unexpected result from server in step ".$when.": '". $line."'");
		echo "\nStream metadata: \n";
		print_r(stream_get_meta_data($fp));
		if ( $when == 4 ) {
		echo "Not auth! Try without authorisation\n";
		}else{
		die("");
		}
	}
}

function parse_one_hierarchy($hier_id,$hier) {
	global $dbconn;
		
	echo "Parsing hierarchy " . $hier ."\n";
	$sql = "SELECT hierarchy, servers, count( * ) AS cnt        FROM `grouplist_hierarchies_temp` where hierarchy ='".addslashes($hier)."' GROUP by hierarchy,servers ORDER BY hierarchy ASC, cnt DESC";
	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error: " . mysql_error());
	while($row=mysql_fetch_row($result)){
			$servers = $row[1];
			$cnt = $row[2];	
	         	$hinfo[] = array("SERVERS" => $servers,
					 "COUNT" => $cnt);
			}
	if(count($hinfo) == 1) {
		if ($hinfo[0]['COUNT'] == 1) {
			// Minihierarchie
			$sql = "SELECT name 
                                FROM grouplist_hierarchies_temp
                                where hierarchy='" . addslashes($hier)."'";
			$result = mysql_query($sql, $dbconn);
			if (!$result)
				die("SQL error subsel1: " . mysql_error());
			if($row=mysql_fetch_row($result)) {
				$singlegroup = $row[0];
				parse_category($hier_id, $hier, $singlegroup, $hinfo[0]['SERVERS'], $hinfo[0]['COUNT']);
			} else {
				die("Group has disappeared!");
			}
			if($row=mysql_fetch_row($result)) {
				die("Internal counting error!");
			}
		} else {
			parse_category($hier_id, $hier, $hier.".AVAILABLE", $hinfo[0]['SERVERS'], $hinfo[0]['COUNT']);
		}
	} else {
		$part = 1;
		foreach($hinfo as $key => $h) {
			$lsize = $h['COUNT'];
			if ($lsize > 5) {
				parse_category($hier_id, $hier, $hier.".PART".$part, $h['SERVERS'], $lsize);
				$part++;
			} else {
				$sql = "SELECT name 
                                        FROM grouplist_hierarchies_temp
                                        where servers='" . addslashes($h['SERVERS']) . "' AND hierarchy='" . addslashes($hier)."'";
				$result = mysql_query($sql, $dbconn);
				if (!$result)
					die("SQL error subsel2: " . mysql_error());
				while($row=mysql_fetch_row($result)) {
					$singlegroup = $row[0];
					parse_category($hier_id, $hier, $singlegroup, "", 0);
				}
			}
		}
	}
}

function parse_category($hier_id, $hier, $name, $servers, $count) {
	global $dbconn;
	if ($count == 0) {
		$cnt = 1;
	} else {
		$cnt = $count;
	}
	$sql = "INSERT INTO grouplist_categories (hierarchy, name, groupcount)
                VALUES (" . intval($hier_id) . ", '" . addslashes($name) . "',
                        " . intval($cnt) . ")";
  	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error insert category: " . mysql_error());	
	$cat_id = mysql_insert_id($dbconn);
	if ($count == 0) {
		$sql = "UPDATE grouplist_groups SET category=" . intval($cat_id) ."
                        WHERE name='" . addslashes($name) . "'";
	} else {
		$sql = "UPDATE grouplist_groups g , grouplist_hierarchies_temp t
 			SET g.category=" . intval($cat_id) ."
                        WHERE g.name=t.name 
                        AND t.servers ='" . addslashes($servers) . "'
                        AND t.hierarchy = '" . addslashes($hier) . "'";
	}
	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error update category: " . mysql_error());
}

function update_cat_server($hier_id) {
         global $dbconn;
         $sql   = "DELETE FROM grouplist_cat_server 
		   WHERE hierarchy ='".addslashes($hier_id)."'";
         $result = mysql_query($sql, $dbconn);
         if (!$result)
		echo "SQL error delete $hier_id grouplist_cat_server: " .mysql_error();
	 $sql  = "INSERT INTO grouplist_cat_server 
			(category, server, hierarchy, count) 
			SELECT c.id, g.server, c.hierarchy, sum(g.count) as count 
		  	FROM grouplist_categories c, grouplist_groups g 
			WHERE c.id = g.category 
			AND c.hierarchy ='" . addslashes($hier_id) . "'   
			GROUP BY c.id, g.server, c.hierarchy";
	 $result = mysql_query($sql, $dbconn);
	 if (!$result)
		echo "Update $hier_id grouplist_cat_server failed.".mysql_error();
}


// end of functions

if (!isset($_GET['admin'])) {
	die();
} else if ($_GET['admin'] != get_config('admin')) {
	die("Login incorrect");
}

if(isset($_GET['continue'])) {
	session_id($_GET['continue']);
}
session_start();
if (!isset($_SESSION['step'])) {
	if(isset($_GET['nofetch'])) {
		$_SESSION['step'] = 40;
		$_SESSION['substep'] = 0;
	} else {
		$_SESSION['step'] = 0;
	}
	$_SESSION['result'] = '';
}
ob_start();
header("Content-Type: text/plain");
echo $_SESSION['result'];

switch($_SESSION['step']) {
case 0:
	echo "Starting grouplist update at " . date("D M j G:i:s T Y")."\n";
	echo "Initializing temp database...\n";
	$sql = "DELETE FROM grouplist_groups_temp";
	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error delete tempdb: " . mysql_error());
	echo "Loading active files...\n";	
	$_SESSION['step'] = 10;
	$_SESSION['substep'] = -1;
	break;
case 10:
	$sql = "SELECT id, name FROM grouplist_servers WHERE id > ".$_SESSION['substep']." ORDER BY id ASC LIMIT 1";
 	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error get servername: " . mysql_error());
	if($row = mysql_fetch_row($result)) {
		$id = $row[0];
		$name = $row[1];
		echo "Handling server " . $id . " (" . $name . ")\n";
		fetch_groups($id, $name);
		$_SESSION['substep'] = $id;
	} else {
		$_SESSION['step'] = 20;
		$_SESSION['substep'] = 0;
	}
	break;
case 20:
	echo "Copying data...<br/>\n";
	$sql = "DELETE FROM grouplist_groups";
	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error copydata1: " . mysql_error());	
	$sql = "INSERT INTO grouplist_groups SELECT * from grouplist_groups_temp";
	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error copydata2: " . mysql_error());
	$_SESSION['step'] = 30;
	break;
case 30:
	echo "Removing temp database...<br/>\n";
	$sql = "DELETE FROM grouplist_groups_temp";
	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error cleartemp: " . mysql_error());	
	set_config('lastupdate', time());
	$_SESSION['step'] = 40;
	break;
case 40:
	echo "Calculating stuff, starting at " . date("D M j G:i:s T Y")."\n";
	echo("Cleaning old hierarchies...\n");
	$sql = "UPDATE grouplist_groups SET category = 0";
 	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error cleangroupcategory: " . mysql_error());
	$sql = "DELETE FROM grouplist_categories";
 	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error cleancategory: " . mysql_error());
	$sql = "DELETE FROM grouplist_hierarchies";
 	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error init cleanhierarchies: " . mysql_error());
	$sql = "DELETE FROM grouplist_hierarchies_temp";
 	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error init cleantmphierarchies: " . mysql_error());
	$_SESSION['step'] = 50;
	break;
case 50:
	echo "Creating group reference lists...\n";
	function store_group_tmp($name, $servers, $hierarchy) {
		global $dbconn;

		$sql="INSERT INTO grouplist_hierarchies_temp (`name`, servers, hierarchy) VALUES ('".addslashes($name)."','".addslashes($servers)."','".addslashes($hierarchy)."');";
		$result = mysql_query($sql, $dbconn);
		if (!$result)
			die("SQL error addgrouptmp: " . mysql_error());
	}
	// get all groups to analyze
	$sql = "SELECT name, server 
                FROM grouplist_groups
                ORDER BY name ASC, server ASC";
 	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error: " . mysql_error());
	$lasthierarchy = null;
	$lastname = null;
	$lastservers = null;
	while($row=mysql_fetch_row($result)) {
		$name = $row[0];
		if ($lastname != $name) {
			if ($lastname != null) {
				store_group_tmp($lastname, 
						implode(",",$lastservers), 
						$lasthierarchy);
			}
			$lastname = $name;
			$lastservers = array();
			$tokens = explode(".", $name);
			$hierarchy = $tokens[0];
			$lasthierarchy = $hierarchy;
		}
		$lastservers[] = intval($row[1]);
	}
	if ($lastname != null) {
		store_group_tmp($lastname, 
				implode(",",$lastservers), 
				$lasthierarchy);
	}	
	$_SESSION['step'] = 60;
	break;
case 60;
	echo "Creating hierarchies...\n";
	$sql = "INSERT INTO grouplist_hierarchies (name)  Select  hierarchy as name FROM grouplist_hierarchies_temp   GROUP BY hierarchy";
	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error: " . mysql_error());
	echo "Creating categories....\n";
	$sql = "SELECT id, name FROM grouplist_hierarchies ORDER BY name";
	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error: " . mysql_error());
	$hinfo=null;
	$lasthierarchy=null;
	while($row=mysql_fetch_row($result)) {
	        $hier_id = $row[0];
	        $hierarchy = $row[1];
		parse_one_hierarchy($hier_id,$hierarchy);
		update_cat_server($hier_id);		
		
	}
	// do some check...
	$sql = "select count(*) from grouplist_groups WHERE category = 0";
 	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error: " . mysql_error());
	$row = mysql_fetch_row($result);
	if ($row[0] != '0') {
		die ($row[0] . " groups are in no category!");
	}
	$_SESSION['step'] = 90;
	break;
case 90:
	echo "Deleting temporary values...\n";
	$sql = "DELETE FROM grouplist_hierarchies_temp";
	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error deletetemp: " . mysql_error());
	echo "Updating caches...\n";
	$sql = "DELETE FROM grouplist_cat_server";
	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error deletecaches: " . mysql_error());
	$sql = "INSERT INTO grouplist_cat_server
                            (category, server, hierarchy, count)
                SELECT c.id, g.server, c.hierarchy, sum(g.count) AS count 
                FROM grouplist_categories c, grouplist_groups g
                WHERE c.id = g.category
                GROUP BY c.id, g.server, c.hierarchy";
	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error fillcaches: " . mysql_error());
	$_SESSION['step'] = 100;
	break;
case 100:
	$sql = "DELETE FROM grouplist_pagecache";
	$result = mysql_query($sql, $dbconn);
	if (!$result)
		die("SQL error delete pagecache: " . mysql_error());
	echo "Update complete at " . date("D M j G:i:s T Y")."\n";
	session_destroy(); // no longer needed
	die("Finished.");
	break;
default:
	 die("Unknown step: " . $_SESSION['step']);
}

$_SESSION['result'] = ob_get_contents();
if(!ob_end_clean()) {
	die("Could not discard output buffer");
}
header("Location: http://" . $_SERVER["HTTP_HOST"] . $_SERVER['SCRIPT_NAME'] . 
       "?admin=" . $_GET['admin'] . "&step=".$_SESSION['step']."_".$_SESSION['substep']."&continue=" . session_id());
?>
